package com.ekexiu.project.bridge.alarm;

import com.ekexiu.project.bridge.system.vo.SessionUser;
import org.jfw.apt.annotation.Autowrie;
import org.jfw.apt.web.annotation.LoginUser;
import org.jfw.apt.web.annotation.Path;
import org.jfw.apt.web.annotation.operate.Get;
import org.jfw.apt.web.annotation.operate.Post;
import org.jfw.apt.web.annotation.param.JdbcConn;
import org.jfw.util.PageQueryResult;
import org.jfw.util.jdbc.JdbcUtil;
import org.jfw.util.jdbc.PreparedStatementConfig;
import org.jfw.util.jdbc.ResultSetExtractor;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Path("/alarm")
public class AlarmService {

	@Autowrie
	private AlarmDao alarmDao;
	
	public AlarmDao getAlarmDao() {
		return alarmDao;
	}

	public void setAlarmDao(AlarmDao alarmDao) {
		this.alarmDao = alarmDao;
	}

	@Get
	@Path("/msg")
	public PageQueryResult<AlarmMsg> query(@JdbcConn Connection con,String[] seq,final @LoginUser SessionUser user,int pageSize,int pageNo)throws SQLException{
		return this.alarmDao.queryAlarmMsg(con,seq,user.getId(), pageSize, pageNo);
	}
	
	@Get
	@Path("/msg/unread")
	public Object query(@JdbcConn Connection con,@LoginUser final SessionUser user,final String[] server)throws SQLException{
		StringBuilder sb = new StringBuilder();
		sb.append("SELECT server,count(1) FROM ALARM_MSG WHERE SERVER IN (?");
		for(int i = 1 ; i < server.length;++i){
			sb.append(",?");
		}
		sb.append(") AND UID=? AND READED='0' GROUP BY SERVER");
		
		return JdbcUtil.queryList(con, sb.toString(), new ResultSetExtractor<Map<String,Object>>() {

			@Override
			public Map<String, Object> extractData(ResultSet rs) throws SQLException {
				Map<String,Object> map = new HashMap<String,Object>();
				String s= rs.getString(1);
				int c = rs.getInt(2);
				map.put("server",s);
				map.put("num",c);
				return map;
			}
		}, new PreparedStatementConfig() {
			
			@Override
			public void config(PreparedStatement ps) throws SQLException {
				int i =0;
				for(;i < server.length;++i ){
					ps.setString(i+1,server[i]);
				}
				ps.setString(i+1,user.getId());
			}
		});
		
	}

	@LoginUser
	@Get
	@Path("/detail")
	public List<AlarmDataItem> query(@JdbcConn Connection con,String aid)throws SQLException{
		return this.alarmDao.query(con, aid);
	}
	
	@Post
	@Path("/msg/read")
	public void read(@JdbcConn(true) Connection con,String aid,@LoginUser SessionUser user)throws SQLException{
		this.alarmDao.readed(con,user.getId(), aid);
	}
}
