package com.ekexiu.project.bridge.resource.dao;

import com.ekexiu.project.bridge.resource.po.CollectDevice;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.Exclude;
import org.jfw.apt.orm.annotation.dao.method.From;
import org.jfw.apt.orm.annotation.dao.method.IncludeFixSet;
import org.jfw.apt.orm.annotation.dao.method.OrderBy;
import org.jfw.apt.orm.annotation.dao.method.SetSentence;
import org.jfw.apt.orm.annotation.dao.method.operator.Insert;
import org.jfw.apt.orm.annotation.dao.method.operator.PageSelect;
import org.jfw.apt.orm.annotation.dao.method.operator.SelectList;
import org.jfw.apt.orm.annotation.dao.method.operator.SelectOne;
import org.jfw.apt.orm.annotation.dao.method.operator.Update;
import org.jfw.apt.orm.annotation.dao.method.operator.UpdateWith;
import org.jfw.apt.orm.annotation.dao.param.In;
import org.jfw.apt.orm.annotation.dao.param.Like;
import org.jfw.apt.orm.annotation.dao.param.Set;
import org.jfw.apt.orm.annotation.dao.param.SqlColumn;
import org.jfw.apt.orm.annotation.dao.param.UnEquals;
import org.jfw.apt.orm.core.defaultImpl.StringHandler;
import org.jfw.util.PageQueryResult;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.List;

/**
 * Created by TT on 2018/8/8.
 */
@DAO
public interface CollectDeviceDao {

    @Insert
    int insert(Connection con, CollectDevice collectDevice) throws SQLException;

    @UpdateWith
    @From(CollectDevice.class)
    @SetSentence("active = '0'")
    @IncludeFixSet("modifyTime")
    int logicDelete(Connection con, @Set String modifier, String id) throws SQLException;

    @UpdateWith
    @From(CollectDevice.class)
    @SetSentence("active = '0'")
    @IncludeFixSet("modifyTime")
    int logicDeleteByServers(Connection con, @Set String modifier,@In String[] serverId) throws SQLException;

    @Update
    @Exclude("active")
    int update(Connection con, CollectDevice collectDevice) throws SQLException;

    @SelectOne
    @Nullable
    CollectDevice query(Connection con, String id) throws SQLException;
    
    @SelectOne
    @Nullable
    CollectDevice query(Connection con, String serverId,int seq) throws SQLException;

    @SelectOne
    @Nullable
    CollectDevice queryBySeqAndServer(Connection con, @SqlColumn(handlerClass = StringHandler.class,value = "SERVER_ID IN (SELECT ID FROM BRIDGE_SERVER WHERE CODE = ?)")String serverId, int seq, @Nullable @UnEquals String id,@Nullable Boolean active) throws SQLException;

    @SelectOne
    @Nullable
    CollectDevice queryByCode(Connection con,String code,@Nullable @UnEquals String id,@Nullable Boolean active) throws SQLException;

    @PageSelect
    @OrderBy("ORDER BY CODE")
    PageQueryResult<CollectDevice> pageQuery(Connection con, @Nullable Boolean active, @Nullable @SqlColumn(handlerClass = StringHandler.class, value = {"SERVER_ID IN (SELECT ID FROM BRIDGE_SERVER WHERE CODE = ?)"}) String serverCode, @Nullable String code, int pageSize, int pageNo) throws SQLException;

    @SelectList
    List<CollectDevice> queryByServer(Connection con,@Nullable Boolean active, String serverId) throws SQLException;

    @SelectList
    List<CollectDevice> queryByServers(Connection con, @Nullable Boolean active, @In String[] serverId) throws SQLException;

    @SelectList
    List<CollectDevice> queryByCode(Connection con, @Nullable Boolean active, @Nullable @Like String code) throws SQLException;
}
